]> git.cworth.org Git - notmuch/blob - test/test-lib.sh
Merge branch 'release'
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For lib/open.cc:_load_key_file
108 unset XDG_CONFIG_HOME
109
110 # For emacsclient
111 unset ALTERNATE_EDITOR
112
113 # for reproducibility
114 unset EMAIL
115 unset NAME
116
117 add_gnupg_home () {
118     [ -e "${GNUPGHOME}/gpg.conf" ] && return
119     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
120     at_exit_function _gnupg_exit
121     mkdir -p -m 0700 "$GNUPGHOME"
122     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
123     test_debug "cat $GNUPGHOME/import.log"
124     if (gpg --quick-random --version >/dev/null 2>&1) ; then
125         echo quick-random >> "$GNUPGHOME"/gpg.conf
126     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
127         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
128     fi
129     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
130
131     # Change this if we ship a new test key
132     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
133     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
134     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
135 }
136
137 add_gpgsm_home () {
138     test_require_external_prereq openssl
139
140     local fpr
141     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
142     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
143     at_exit_function _gnupg_exit
144     mkdir -p -m 0700 "$GNUPGHOME"
145     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
146         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
147         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
148               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
149     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
150     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
151     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
152     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
153     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
154     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
155               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
156     test_debug "cat $GNUPGHOME/import.log"
157 }
158
159 # Each test should start with something like this, after copyright notices:
160 #
161 # test_description='Description of this test...
162 # This test checks if command xyzzy does the right thing...
163 # '
164 # . ./test-lib.sh || exit 1
165
166 color=maybe
167
168 while test "$#" -ne 0
169 do
170         case "$1" in
171         -d|--debug)
172                 debug=t; shift ;;
173         -i|--immediate)
174                 immediate=t; shift ;;
175         -h|--help)
176                 help=t; shift ;;
177         -v|--verbose)
178                 verbose=t; shift ;;
179         -q|--quiet)
180                 quiet=t; shift ;;
181         --with-dashes)
182                 with_dashes=t; shift ;;
183         --no-color)
184                 color=; shift ;;
185         --no-python)
186                 # noop now...
187                 shift ;;
188         --valgrind)
189                 valgrind=t; verbose=t; shift ;;
190         --tee)
191                 shift ;; # was handled already
192         *)
193                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
194         esac
195 done
196
197 if test -n "$debug"; then
198         fmt_subtest () {
199                 printf -v $1 " %-4s" "[$((test_count - 1))]"
200         }
201 else
202         fmt_subtest () {
203                 printf -v $1 ''
204         }
205 fi
206
207 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
208
209 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] &&
210         tput -T "$ORIGINAL_TERM" -S <<<$'bold\nsetaf\nsgr0\n' >/dev/null 2>&1
211 then
212         color=t
213 else
214         color=
215 fi
216
217 if test -n "$color"
218 then
219         # _tput run in subshell (``) only
220         _tput () { exec tput -T "$ORIGINAL_TERM" "$@"; }
221         unset BOLD RED GREEN BROWN SGR0
222         say_color () {
223                 case "$1" in
224                         error)  b=${BOLD=`_tput bold`}
225                                 c=${RED=`_tput setaf 1`}   ;; # bold red
226                         skip)   b=${BOLD=`_tput bold`}
227                                 c=${GREEN=`_tput setaf 2`} ;; # bold green
228                         pass)   b= c=${GREEN=`_tput setaf 2`} ;; # green
229                         info)   b= c=${BROWN=`_tput setaf 3`} ;; # brown
230                         *) b= c=; test -n "$quiet" && return ;;
231                 esac
232                 f=$2
233                 shift 2
234                 sgr0=${SGR0=`_tput sgr0`}
235                 fmt_subtest st
236                 printf " ${b}${c}${f}${sgr0}${st}" "$@"
237         }
238 else
239         say_color() {
240                 test -z "$1" && test -n "$quiet" && return
241                 f=$2
242                 shift 2
243                 fmt_subtest st
244                 printf " ${f}${st}" "$@"
245         }
246 fi
247
248 error () {
249         say_color error "error: $*\n"
250         GIT_EXIT_OK=t
251         exit 1
252 }
253
254 say () {
255         say_color info "$*"
256 }
257
258 test "${test_description}" != "" ||
259 error "Test script did not set test_description."
260
261 if test "$help" = "t"
262 then
263         echo "Tests ${test_description}"
264         exit 0
265 fi
266
267 test_description_printed=
268 print_test_description () {
269         test -z "$test_description_printed" || return 0
270         echo
271         echo $this_test: "Testing ${test_description}"
272         test_description_printed=1
273 }
274 if [ -z "$NOTMUCH_TEST_QUIET" ]
275 then
276         print_test_description
277 fi
278
279 test_failure=0
280 test_count=0
281 test_fixed=0
282 test_broken=0
283 test_success=0
284
285 declare -a _exit_functions=()
286
287 at_exit_function () {
288         _exit_functions=($1 ${_exit_functions[@]/$1})
289 }
290
291 rm_exit_function () {
292         _exit_functions=(${_exit_functions[@]/$1})
293 }
294
295 _exit_common () {
296         code=$?
297         trap - EXIT
298         set +ex
299         for _fn in ${_exit_functions[@]}; do $_fn; done
300         rm -rf "$TEST_TMPDIR"
301 }
302
303 trap_exit () {
304         _exit_common
305         if test -n "$GIT_EXIT_OK"
306         then
307                 exit $code
308         else
309                 exec >&6
310                 say_color error '%-6s' FATAL
311                 echo " $test_subtest_name"
312                 echo
313                 echo "Unexpected exit while executing $0. Exit code $code."
314                 exit 1
315         fi
316 }
317
318 trap_signal () {
319         _exit_common
320         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
321         exit $code
322 }
323
324 die () {
325         _exit_common
326         exec >&6
327         say_color error '%-6s' FATAL
328         echo " $*"
329         echo
330         echo "Unexpected exit while executing $0."
331         exit 1
332 }
333
334 GIT_EXIT_OK=
335 # Note: TEST_TMPDIR *NOT* exported!
336 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
337 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
338 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
339 trap 'trap_exit' EXIT
340 trap 'trap_signal' HUP INT TERM
341
342 # Add an existing, fixed corpus of email to the database.
343 #
344 # $1 is the corpus dir under corpora to add, using "default" if unset.
345 #
346 # The default corpus is based on about 50 messages from early in the
347 # history of the notmuch mailing list, which allows for reliably
348 # testing commands that need to operate on a not-totally-trivial
349 # number of messages.
350 add_email_corpus () {
351     local corpus
352     corpus=${1:-default}
353
354     rm -rf ${MAIL_DIR}
355     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
356     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
357 }
358
359 test_begin_subtest () {
360     if [ -n "$inside_subtest" ]; then
361         exec 1>&6 2>&7          # Restore stdout and stderr
362         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
363     fi
364     test_subtest_name="$1"
365     test_reset_state_
366     # Redirect test output to the previously prepared file descriptors
367     # 3 and 4 (see below)
368     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
369     exec >&3 2>&4
370     inside_subtest=t
371 }
372
373 # Pass test if two arguments match
374 #
375 # Note: Unlike all other test_expect_* functions, this function does
376 # not accept a test name. Instead, the caller should call
377 # test_begin_subtest before calling this function in order to set the
378 # name.
379 test_expect_equal () {
380         local output expected testname
381         exec 1>&6 2>&7          # Restore stdout and stderr
382         if [ -z "$inside_subtest" ]; then
383                 error "bug in the test script: test_expect_equal without test_begin_subtest"
384         fi
385         inside_subtest=
386         test "$#" = 2 ||
387         error "bug in the test script: not 2 parameters to test_expect_equal"
388
389         output="$1"
390         expected="$2"
391         if ! test_skip "$test_subtest_name"
392         then
393                 if [ "$output" = "$expected" ]; then
394                         test_ok_
395                 else
396                         testname=$this_test.$test_count
397                         echo "$expected" > $testname.expected
398                         echo "$output" > $testname.output
399                         test_failure_ "$(diff -u $testname.expected $testname.output)"
400                 fi
401     fi
402 }
403
404 # Like test_expect_equal, but takes two filenames.
405 test_expect_equal_file () {
406         local file1 file2 testname basename1 basename2
407         exec 1>&6 2>&7          # Restore stdout and stderr
408         if [ -z "$inside_subtest" ]; then
409                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
410         fi
411         inside_subtest=
412         test "$#" = 2 ||
413         error "bug in the test script: not 2 parameters to test_expect_equal_file"
414
415         file1="$1"
416         file2="$2"
417         if ! test_skip "$test_subtest_name"
418         then
419                 if diff -q "$file1" "$file2" >/dev/null ; then
420                         test_ok_
421                 else
422                         testname=$this_test.$test_count
423                         basename1=`basename "$file1"`
424                         basename2=`basename "$file2"`
425                         cp "$file1" "$testname.$basename1"
426                         cp "$file2" "$testname.$basename2"
427                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
428                 fi
429     fi
430 }
431
432 # Like test_expect_equal, but arguments are JSON expressions to be
433 # canonicalized before diff'ing.  If an argument cannot be parsed, it
434 # is used unchanged so that there's something to diff against.
435 test_expect_equal_json () {
436     local script output expected
437     # The test suite forces LC_ALL=C, but this causes Python 3 to
438     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
439     # override Python's stdio encoding defaults.
440     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
441     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
442         || echo "$1")
443     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
444         || echo "$2")
445     shift 2
446     test_expect_equal "$output" "$expected" "$@"
447 }
448
449 # Ensure that the argument is valid JSON data.
450 test_valid_json () {
451     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
452     test_expect_equal "$?" 0
453 }
454
455 # Sort the top-level list of JSON data from stdin.
456 test_sort_json () {
457     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
458         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
459 }
460
461 # test for json objects:
462 # read the source of test/json_check_nodes.py (or the output when
463 # invoking it without arguments) for an explanation of the syntax.
464 test_json_nodes () {
465         local output
466         exec 1>&6 2>&7          # Restore stdout and stderr
467         if [ -z "$inside_subtest" ]; then
468                 error "bug in the test script: test_json_eval without test_begin_subtest"
469         fi
470         inside_subtest=
471         test "$#" > 0 ||
472             error "bug in the test script: test_json_nodes needs at least 1 parameter"
473
474         if ! test_skip "$test_subtest_name"
475         then
476             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
477                 if [ "$?" = 0 ]
478                 then
479                         test_ok_
480                 else
481                         test_failure_ "$output"
482                 fi
483         fi
484 }
485
486 NOTMUCH_NEW () {
487     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
488 }
489
490 NOTMUCH_DUMP_TAGS () {
491     # this relies on the default format being batch-tag, otherwise some tests will break
492     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
493 }
494
495 notmuch_drop_mail_headers () {
496     $NOTMUCH_PYTHON -c '
497 import email, sys
498 msg = email.message_from_file(sys.stdin)
499 for hdr in sys.argv[1:]: del msg[hdr]
500 print(msg.as_string(False))
501 ' "$@"
502 }
503
504 notmuch_debug_sanitize () {
505     grep -v '^D.:'
506 }
507
508 notmuch_exception_sanitize () {
509     perl -pe 's/(A Xapian exception occurred at .*[.]cc?):([0-9]*)/\1:XXX/'
510 }
511
512 notmuch_search_sanitize () {
513     notmuch_debug_sanitize | perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
514 }
515
516 notmuch_search_files_sanitize () {
517     notmuch_dir_sanitize
518 }
519
520 notmuch_dir_sanitize () {
521     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
522 }
523
524 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
525 notmuch_show_sanitize () {
526     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
527 }
528 notmuch_show_sanitize_all () {
529     notmuch_debug_sanitize | \
530     sed \
531         -e 's| filename:.*| filename:XXXXX|' \
532         -e 's| id:[^ ]* | id:XXXXX |' | \
533         notmuch_date_sanitize
534 }
535
536 notmuch_json_show_sanitize () {
537     sed \
538         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
539         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
540         -e 's|"filename": "signature.asc",||g' \
541         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
542         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
543         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
544 }
545
546 notmuch_emacs_error_sanitize () {
547     local command
548     command=$1
549     shift
550     for file in "$@"; do
551         echo "=== $file ==="
552         notmuch_debug_sanitize < "$file"
553     done | sed \
554         -e '/^$/d' \
555         -e '/^\[.*\]$/d' \
556         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
557 }
558
559 notmuch_date_sanitize () {
560     sed \
561         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
562 }
563
564 notmuch_uuid_sanitize () {
565     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
566 }
567
568 notmuch_built_with_sanitize () {
569     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
570 }
571
572 notmuch_config_sanitize () {
573     notmuch_dir_sanitize | notmuch_built_with_sanitize
574 }
575
576 notmuch_show_part () {
577     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
578 }
579
580 # End of notmuch helper functions
581
582 # Use test_set_prereq to tell that a particular prerequisite is available.
583 #
584 # The prerequisite can later be checked for by using test_have_prereq.
585 #
586 # The single parameter is the prerequisite tag (a simple word, in all
587 # capital letters by convention).
588
589 test_set_prereq () {
590         satisfied="$satisfied$1 "
591 }
592 satisfied=" "
593
594 test_have_prereq () {
595         case $satisfied in
596         *" $1 "*)
597                 : yes, have it ;;
598         *)
599                 ! : nope ;;
600         esac
601 }
602
603 declare -A test_missing_external_prereq_
604 declare -A test_subtest_missing_external_prereq_
605
606 # declare prerequisite for the given external binary
607 test_declare_external_prereq () {
608         local binary
609         binary="$1"
610         test "$#" = 2 && name=$2 || name="$binary(1)"
611
612         if ! hash $binary 2>/dev/null; then
613                 test_missing_external_prereq_["${binary}"]=t
614                 eval "
615 $binary () {
616         test_subtest_missing_external_prereq_[\"${name}\"]=t
617         false
618 }"
619         fi
620 }
621
622 # Explicitly require external prerequisite.  Useful when binary is
623 # called indirectly (e.g. from emacs).
624 # Returns success if dependency is available, failure otherwise.
625 test_require_external_prereq () {
626         local binary
627         binary="$1"
628         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
629                 # dependency is missing, call the replacement function to note it
630                 eval "$binary"
631         else
632                 true
633         fi
634 }
635
636 # You are not expected to call test_ok_ and test_failure_ directly, use
637 # the text_expect_* functions instead.
638
639 test_ok_ () {
640         if test "$test_subtest_known_broken_" = "t"; then
641                 test_known_broken_ok_
642                 return
643         fi
644         test_success=$(($test_success + 1))
645         if test -n "$NOTMUCH_TEST_QUIET"; then
646                 return 0
647         fi
648         say_color pass "%-6s" "PASS"
649         echo " $test_subtest_name"
650 }
651
652 test_failure_ () {
653         print_test_description
654         if test "$test_subtest_known_broken_" = "t"; then
655                 test_known_broken_failure_ "$@"
656                 return
657         fi
658         test_failure=$(($test_failure + 1))
659         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
660         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
661         return 1
662 }
663
664 test_failure_message_ () {
665         say_color error "%-6s" "$1"
666         echo " $2"
667         shift 2
668         if [ "$#" != "0" ]; then
669                 echo "$@" | sed -e 's/^/        /'
670         fi
671         if test "$verbose" != "t"; then cat test.output; fi
672 }
673
674 test_known_broken_ok_ () {
675         test_reset_state_
676         test_fixed=$(($test_fixed+1))
677         say_color pass "%-6s" "FIXED"
678         echo " $test_subtest_name"
679 }
680
681 test_known_broken_failure_ () {
682         test_reset_state_
683         test_broken=$(($test_broken+1))
684         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
685                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
686         else
687                 test_failure_message_ "BROKEN" "$test_subtest_name"
688         fi
689         return 1
690 }
691
692 test_debug () {
693         test "$debug" = "" || eval "$1"
694 }
695
696 test_run_ () {
697         test_cleanup=:
698         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
699         eval >&3 2>&4 "$1"
700         eval_ret=$?
701         eval >&3 2>&4 "$test_cleanup"
702         return 0
703 }
704
705 test_skip () {
706         test_count=$(($test_count+1))
707         to_skip=
708         for skp in $NOTMUCH_SKIP_TESTS
709         do
710                 case $this_test.$test_count in
711                 $skp)
712                         to_skip=t
713                         break
714                 esac
715                 case $this_test_bare.$test_count in
716                 $skp)
717                         to_skip=t
718                         break
719                 esac
720         done
721         case "$to_skip" in
722         t)
723                 test_report_skip_ "$@"
724                 ;;
725         *)
726                 test_check_missing_external_prereqs_ "$@"
727                 ;;
728         esac
729 }
730
731 test_check_missing_external_prereqs_ () {
732         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
733                 say_color skip >&1 "missing prerequisites: "
734                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
735                 test_report_skip_ "$@"
736         else
737                 false
738         fi
739 }
740
741 test_report_skip_ () {
742         test_reset_state_
743         say_color skip >&3 "skipping test:"
744         echo " $@" >&3
745         say_color skip "%-6s" "SKIP"
746         echo " $1"
747 }
748
749 test_subtest_known_broken () {
750         test_subtest_known_broken_=t
751 }
752
753 test_expect_success () {
754         exec 1>&6 2>&7          # Restore stdout and stderr
755         if [ -z "$inside_subtest" ]; then
756                 error "bug in the test script: test_expect_success without test_begin_subtest"
757         fi
758         inside_subtest=
759         test "$#" = 1 ||
760         error "bug in the test script: not 1 parameters to test_expect_success"
761
762         if ! test_skip "$test_subtest_name"
763         then
764                 test_run_ "$1"
765                 run_ret="$?"
766                 # test_run_ may update missing external prerequisites
767                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
768                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
769                 then
770                         test_ok_
771                 else
772                         test_failure_ "$1"
773                 fi
774         fi
775 }
776
777 test_expect_code () {
778         exec 1>&6 2>&7          # Restore stdout and stderr
779         if [ -z "$inside_subtest" ]; then
780                 error "bug in the test script: test_expect_code without test_begin_subtest"
781         fi
782         inside_subtest=
783         test "$#" = 2 ||
784         error "bug in the test script: not 2 parameters to test_expect_code"
785
786         if ! test_skip "$test_subtest_name"
787         then
788                 test_run_ "$2"
789                 run_ret="$?"
790                 # test_run_ may update missing external prerequisites,
791                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
792                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
793                 then
794                         test_ok_
795                 else
796                         test_failure_ "exit code $eval_ret, expected $1" "$2"
797                 fi
798         fi
799 }
800
801 # This is not among top-level (test_expect_success)
802 # but is a prefix that can be used in the test script, like:
803 #
804 #       test_expect_success 'complain and die' '
805 #           do something &&
806 #           do something else &&
807 #           test_must_fail git checkout ../outerspace
808 #       '
809 #
810 # Writing this as "! git checkout ../outerspace" is wrong, because
811 # the failure could be due to a segv.  We want a controlled failure.
812
813 test_must_fail () {
814         "$@"
815         test $? -gt 0 -a $? -le 129 -o $? -gt 192
816 }
817
818 # test_cmp is a helper function to compare actual and expected output.
819 # You can use it like:
820 #
821 #       test_expect_success 'foo works' '
822 #               echo expected >expected &&
823 #               foo >actual &&
824 #               test_cmp expected actual
825 #       '
826 #
827 # This could be written as either "cmp" or "diff -u", but:
828 # - cmp's output is not nearly as easy to read as diff -u
829 # - not all diff versions understand "-u"
830
831 test_cmp () {
832         $GIT_TEST_CMP "$@"
833 }
834
835 # This function can be used to schedule some commands to be run
836 # unconditionally at the end of the test to restore sanity:
837 #
838 #       test_expect_success 'test core.capslock' '
839 #               git config core.capslock true &&
840 #               test_when_finished "git config --unset core.capslock" &&
841 #               hello world
842 #       '
843 #
844 # That would be roughly equivalent to
845 #
846 #       test_expect_success 'test core.capslock' '
847 #               git config core.capslock true &&
848 #               hello world
849 #               git config --unset core.capslock
850 #       '
851 #
852 # except that the greeting and config --unset must both succeed for
853 # the test to pass.
854
855 test_when_finished () {
856         test_cleanup="{ $*
857                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
858 }
859
860 test_done () {
861         GIT_EXIT_OK=t
862         test_results_dir="$TEST_DIRECTORY/test-results"
863         test -d "$test_results_dir" || mkdir "$test_results_dir"
864         test_results_path="$test_results_dir/$this_test"
865
866         printf %s\\n \
867                 "success $test_success" \
868                 "fixed $test_fixed" \
869                 "broken $test_broken" \
870                 "failed $test_failure" \
871                 "total $test_count" \
872             > $test_results_path
873
874         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
875
876         if [ "$test_failure" = "0" ]; then
877             if [ "$test_broken" = "0" ]; then
878                 rm -rf "$remove_tmp"
879             fi
880             exit 0
881         else
882             exit 1
883         fi
884 }
885
886 test_python () {
887     # Note: if there is need to print debug information from python program,
888     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
889     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
890         $NOTMUCH_PYTHON -B - > OUTPUT
891 }
892
893 test_C () {
894     local exec_file test_file
895     exec_file="test${test_count}"
896     test_file="${exec_file}.c"
897     cat > ${test_file}
898     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
899     echo "== stdout ==" > OUTPUT.stdout
900     echo "== stderr ==" > OUTPUT.stderr
901     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
902     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
903 }
904
905 make_shim () {
906     local base_name test_file shim_file
907     base_name="$1"
908     test_file="${base_name}.c"
909     shim_file="${base_name}.so"
910     cat > ${test_file}
911     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
912 }
913
914 notmuch_with_shim () {
915     local base_name shim_file
916     base_name="$1"
917     shift
918     shim_file="${base_name}.so"
919     LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
920 }
921
922 # Creates a script that counts how much time it is executed and calls
923 # notmuch.  $notmuch_counter_command is set to the path to the
924 # generated script.  Use notmuch_counter_value() function to get the
925 # current counter value.
926 notmuch_counter_reset () {
927         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
928         if [ ! -x "$notmuch_counter_command" ]; then
929                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
930                 cat >"$notmuch_counter_command" <<EOF || return
931 #!/bin/sh
932
933 read count < "$notmuch_counter_state_path"
934 echo \$((count + 1)) > "$notmuch_counter_state_path"
935
936 exec notmuch "\$@"
937 EOF
938                 chmod +x "$notmuch_counter_command" || return
939         fi
940
941         echo 0 > "$notmuch_counter_state_path"
942 }
943
944 # Returns the current notmuch counter value.
945 notmuch_counter_value () {
946         if [ -r "$notmuch_counter_state_path" ]; then
947                 read count < "$notmuch_counter_state_path"
948         else
949                 count=0
950         fi
951         echo $count
952 }
953
954 test_reset_state_ () {
955         test -z "$test_init_done_" && test_init_
956
957         test_subtest_known_broken_=
958         test_subtest_missing_external_prereq_=()
959 }
960
961 # called once before the first subtest
962 test_init_ () {
963         test_init_done_=t
964
965         # skip all tests if there were external prerequisites missing during init
966         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
967 }
968
969
970 # Where to run the tests
971 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
972
973 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
974
975 # Use -P to resolve symlinks in our working directory so that the cwd
976 # in subprocesses like git equals our $PWD (for pathname comparisons).
977 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
978
979 if test "$verbose" = "t"
980 then
981         exec 4>&2 3>&1
982 else
983         exec 4>test.output 3>&4
984 fi
985
986 for skp in $NOTMUCH_SKIP_TESTS
987 do
988         to_skip=
989         for skp in $NOTMUCH_SKIP_TESTS
990         do
991                 case "$this_test" in
992                 $skp)
993                         to_skip=t
994                         break
995                 esac
996                 case "$this_test_bare" in
997                 $skp)
998                         to_skip=t
999                         break
1000                 esac
1001         done
1002         case "$to_skip" in
1003         t)
1004                 say_color skip >&3 "skipping test $this_test altogether"
1005                 say_color skip "skip all tests in $this_test"
1006                 test_done
1007         esac
1008 done
1009
1010 # Provide an implementation of the 'yes' utility
1011 yes () {
1012         if test $# = 0
1013         then
1014                 y=y
1015         else
1016                 y="$*"
1017         fi
1018
1019         while echo "$y"
1020         do
1021                 :
1022         done
1023 }
1024
1025 # Fix some commands on Windows
1026 case $(uname -s) in
1027 *MINGW*)
1028         # Windows has its own (incompatible) sort and find
1029         sort () {
1030                 /usr/bin/sort "$@"
1031         }
1032         find () {
1033                 /usr/bin/find "$@"
1034         }
1035         sum () {
1036                 md5sum "$@"
1037         }
1038         # git sees Windows-style pwd
1039         pwd () {
1040                 builtin pwd -W
1041         }
1042         # no POSIX permissions
1043         # backslashes in pathspec are converted to '/'
1044         # exec does not inherit the PID
1045         ;;
1046 *)
1047         test_set_prereq POSIXPERM
1048         test_set_prereq BSLASHPSPEC
1049         test_set_prereq EXECKEEPSPID
1050         ;;
1051 esac
1052
1053 test -z "$NO_PERL" && test_set_prereq PERL
1054 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1055
1056 # test whether the filesystem supports symbolic links
1057 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1058 rm -f y
1059
1060 # declare prerequisites for external binaries used in tests
1061 test_declare_external_prereq dtach
1062 test_declare_external_prereq emacs
1063 test_declare_external_prereq ${TEST_EMACSCLIENT}
1064 test_declare_external_prereq ${TEST_GDB}
1065 test_declare_external_prereq gpg
1066 test_declare_external_prereq openssl
1067 test_declare_external_prereq gpgsm
1068 test_declare_external_prereq ${NOTMUCH_PYTHON}
1069 test_declare_external_prereq xapian-metadata
1070 test_declare_external_prereq xapian-delve